import java.awt.*;

public class DrawingAirBomber extends DrawingAir {

    public DrawingAirBomber(int speed, double weight, Color bodyColor,
                            Color additionalColor, boolean rocket, boolean toplivo, int width, int height, int enginesType, int enginesNumber){
        super(speed, weight, bodyColor, width, height, enginesType, enginesNumber);
        if(entityAir != null)
            entityAir = new EntityAirBomber(speed, weight, bodyColor, additionalColor,rocket, toplivo);
    }

    public void drawTransport(Graphics2D g)
    {
        if (!(entityAir instanceof EntityAirBomber))
            return;
        EntityAirBomber entityAirBomber = (EntityAirBomber) entityAir;
        BasicStroke pen = new BasicStroke(2);
        Color penColor = Color.BLACK;
        Color additionalColor = entityAirBomber.getAdditionalColor();
        g.setStroke(pen);
        super.drawTransport(g);
        // топливо
        if (entityAirBomber.getFuel())
        {
            int[] pointX = new int[]{_startPosX + 60, _startPosX + 60, _startPosX + 100, _startPosX + 100};
            int[] pointY = new int[]{_startPosY + 10, _startPosY, _startPosY, _startPosY + 10};
            g.setColor(penColor);
            g.fillPolygon(pointX, pointY, 4);
            pointX = new int[]{_startPosX + 60, _startPosX + 60, _startPosX + 100, _startPosX + 100};
            pointY = new int[]{_startPosY + 160, _startPosY + 150, _startPosY + 150, _startPosY + 160};
            g.setColor(penColor);
            g.fillPolygon(pointX, pointY, 4);
        }
        //ракеты
        if (entityAirBomber.getBombs())
        {
            int[] pointX = new int[]{_startPosX+70, _startPosX+55, _startPosX+70, _startPosX+70};
            int[] pointY = new int[]{_startPosY+30, _startPosY+20, _startPosY+10, _startPosY+30};
            g.setColor(additionalColor);
            g.fillPolygon(pointX, pointY, 4);
            pointX = new int[]{_startPosX+70, _startPosX+55, _startPosX+70, _startPosX+70};
            pointY = new int[]{_startPosY+60, _startPosY+50, _startPosY+40, _startPosY+60};
            g.setColor(additionalColor);
            g.fillPolygon(pointX, pointY, 4);
            pointX = new int[]{_startPosX+70, _startPosX+55, _startPosX+70, _startPosX+70};
            pointY = new int[]{_startPosY+120, _startPosY+110, _startPosY+100, _startPosY+120};
            g.setColor(additionalColor);
            g.fillPolygon(pointX, pointY, 4);
            pointX = new int[]{_startPosX+70, _startPosX+55, _startPosX+70, _startPosX+70};
            pointY = new int[]{_startPosY+150, _startPosY+140, _startPosY+130, _startPosY+150};
            g.setColor(additionalColor);
            g.fillPolygon(pointX, pointY, 4);
        }
    }
}