public class DrawingObjectAirBomber implements IMoveableObject{
    private final DrawingAir drawingAir;

    public DrawingObjectAirBomber(DrawingAir drawingPlane){
        this.drawingAir = drawingPlane;
    }
    public ObjectParameters getObjectPosition(){
        if(drawingAir == null || drawingAir.getEntityPlane() == null)
            return null;
        return new ObjectParameters(drawingAir.getPosX(), drawingAir.getPosY(),
                drawingAir.getWidth(), drawingAir.getHeight());
    }
    public int getStep(){
        if(drawingAir.getEntityPlane() == null)
            return 0;
        return drawingAir.getEntityPlane().step.get().intValue();
    }
    public boolean checkCanMove(DirectionType direction){
        if(drawingAir == null)
            return false;
        return drawingAir.canMove(direction);
    }
    public void moveObject(DirectionType direction){
        drawingAir.moveTransport(direction);
    }
}

