public class DrawingObjectPlane implements IMoveableObject{
    private final DrawingAir drawingPlane;
    public DrawingObjectPlane(DrawingAir drawingPlane){
        this.drawingPlane = drawingPlane;
    }
    public ObjectParameters getObjectPosition(){
        if(drawingPlane == null || drawingPlane.getEntityAir() == null)
            return null;
        return new ObjectParameters(drawingPlane.getPosX(), drawingPlane.getPosY(),
                drawingPlane.getWidth(), drawingPlane.getHeight());
    }
    public int getStep(){
        if(drawingPlane.getEntityAir() == null)
            return 0;
        return drawingPlane.getEntityAir().step.get().intValue();
    }
    public boolean checkCanMove(DirectionType direction){
        if(drawingPlane == null)
            return false;
        return drawingPlane.canMove(direction);
    }
    public void moveObject(DirectionType direction){
        drawingPlane.moveTransport(direction);
    }
}
