import javax.swing.*;
import java.awt.*;
import java.io.IOException;

public class FramePlaneCollection extends JFrame {
    private BomberGenericCollection<DrawingAir, DrawingObjectPlane> planes;
    JComponent pictureBoxCollection;
    TextField textFieldNumber;
    public FramePlaneCollection(){
        super("Набор самолетов");
        setSize(new Dimension(900,600));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        creteGUI();
        planes = new BomberGenericCollection<>(pictureBoxCollection.getWidth(), pictureBoxCollection.getHeight());
        pictureBoxCollection.repaint();
        setVisible(true);
    }

    public void creteGUI(){
        pictureBoxCollection = new JComponent(){
            public void paintComponent(Graphics graphics){
                super.paintComponent(graphics);
                Graphics2D graphics2D = (Graphics2D) graphics;
                if (planes != null) planes.ShowPlanes(graphics2D);
                super.repaint();
            }
        };
        pictureBoxCollection.setBounds(0, 0, 700, 600);
        JButton buttonAddPlane = new JButton("Добавить самолет");
        textFieldNumber = new TextField();
        JButton buttonRemovePlane = new JButton("Удалить самолет");
        JButton buttonRefreshCollection = new JButton("Обновить коллекцию");
        //ActionListeners
        buttonAddPlane.addActionListener(e -> ButtonAddPlaneClick());
        buttonRemovePlane.addActionListener(e -> ButtonRemovePlaneClick());
        buttonRefreshCollection.addActionListener(e -> ButtonRefreshCollectionClick());
        //addition to panel
        JPanel panelCollection = new JPanel(new GridBagLayout());
        GridBagConstraints constraints = new GridBagConstraints();
        constraints.insets.left = constraints.insets.right = 2;
        constraints.insets.top = constraints.insets.bottom = 20;
        constraints.fill = GridBagConstraints.BOTH;
        constraints.gridx = 0;
        constraints.gridy = 0;
        panelCollection.add(buttonAddPlane, constraints);
        constraints.gridx = 0;
        constraints.gridy = 1;
        panelCollection.add(textFieldNumber, constraints);
        constraints.gridx = 0;
        constraints.gridy = 2;
        panelCollection.add(buttonRemovePlane, constraints);
        constraints.gridx = 0;
        constraints.gridy = 5;
        panelCollection.add(buttonRefreshCollection, constraints);
        JPanel upperPanel = new JPanel(new BorderLayout());
        setLayout(new BorderLayout());
        add(panelCollection, BorderLayout.EAST);
        add(pictureBoxCollection, BorderLayout.CENTER);
    }

    private void ButtonAddPlaneClick(){
        FrameAirBomber form;
        try {
            form = new FrameAirBomber();
        } catch (IOException e){
            throw new RuntimeException(e);
        }
        form.selectPlaneButton.addActionListener(e -> {
            form.select();
            var selectedPlane = form.getSelectedPlane();
            form.dispose();
            if (planes.Insert(selectedPlane))
            {
                JOptionPane.showMessageDialog(this, "Объект добавлен");
                pictureBoxCollection.repaint();
            }
            else
            {
                JOptionPane.showMessageDialog(this, "Не удалось добавить объект");
            }
        });
    }

    private void ButtonRemovePlaneClick()
    {
        int pos = Integer.parseInt(textFieldNumber.getText());
        if (planes.Remove(pos))
        {
            JOptionPane.showMessageDialog(this, "Объект удален");
            pictureBoxCollection.repaint();
        }
        else
        {
            JOptionPane.showMessageDialog(this, "Не удалось удалить объект");
        }
    }

    private void ButtonRefreshCollectionClick()
    {
        pictureBoxCollection.repaint();
    }
}
