import java.lang.reflect.Array;

public class SetGeneric<T extends Object>{
    private final T[] places;
    public int getCount() {return places.length;}
    public SetGeneric(int count, Class<T> type){
        places = (T[])Array.newInstance(type, count);
    }
    public boolean insert(T plane){
        return insert(plane, 0);
    }
    public boolean insert(T plane, int position){
        if (!(position >= 0 && position < places.length))
            return false;
        if (places[position] != null)
        {
            int ind = position;
            while (ind < places.length && places[ind] != null)
                ind++;
            if (ind == places.length)
                return false;
            for (int i = ind - 1; i >= position; i--)
                places[i + 1] = places[i];
        }
        places[position] = plane;
        return true;
    }
    public boolean remove(int position){
        if(!(position >= 0 && position < getCount()))
            return false;
        places[position] = null;
        return true;
    }
    public T Get(int position){
        if(!(position >= 0 && position < getCount()))
            return null;
        return places[position];
    }
}